﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace SuperTicTacToe
{
    class Space
    {
        public static MouseState mouseStateSquareCS;
        public static bool mousePressed;
        Vector2 boardLocation;
        Vector2 location;
        public static int currentPlayer = 1;
        public static bool swichplayer = false;
        bool hasXO = false;
        public static Texture2D textureX;
        public static Texture2D textureO;
        public static Texture2D textureNone;
        private Texture2D spaceTexture;
        Rectangle rectangleSquare;
        private int whichBoardCol;
        private int whichBoardRow;
        public int contains = 0; //This is what is inside the square.. It is defined when I pick texture. I used int as opposed to a enum.. 0 is nothing, 1 is X and 2 is O.

        public Space(Vector2 smallBoardLocation, int indexCol, int indexRow)
        {
            whichBoardCol = indexCol;
            whichBoardRow = indexRow; //========================== I am going to use these two numbers inside my update so I can tell which board to go into next ====== LAST PLACE I WAS
            boardLocation = smallBoardLocation;
            float locationX = (smallBoardLocation.X + indexRow * (64 + 16)); //this math takes the index of which space in the array it is (0, 1 or 2) and moves the start of the drawing to the respectave space.
            float locationY = (smallBoardLocation.Y + indexCol * (64 + 16)); //this does the same.. but with the Y cord.
            location = new Vector2(locationX, locationY);
            rectangleSquare = new Rectangle((int)location.X, (int)location.Y, 64, 64);
        }
        public void Update()
        {

            if ((mousePressed == true) && (rectangleSquare.Contains((mouseStateSquareCS.X), (mouseStateSquareCS.Y))) && !(hasXO == true))
            {
                hasXO = true;
                if (currentPlayer == 1)
                {
                    contains = 1;
                    spaceTexture = textureX;
                    currentPlayer = 2;
                    BigBoard.nextMoveBoardCol = whichBoardCol;
                    BigBoard.nextMoveBoardRow = whichBoardRow;
                }
                else if (currentPlayer == 2)
                {
                    contains = 2;
                    spaceTexture = textureO;
                    currentPlayer = 1;
                    BigBoard.nextMoveBoardCol = whichBoardCol;
                    BigBoard.nextMoveBoardRow = whichBoardRow;
                }
            }
            else if (hasXO == false)
            {
                contains = 0;
                spaceTexture = textureNone;
            }

        }

        
        public void Draw(SpriteBatch spritebatch)
        {
            spritebatch.Draw(spaceTexture, rectangleSquare, Color.White);
        }
    }
}
