﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;


namespace SuperTicTacToe
{
    class BigBoard
    {
        public static bool gameOver = false;
        public static int nextMoveBoardCol = 1;
        public static int nextMoveBoardRow = 1;
        private int goOnce = 0;
        public static Texture2D bigBoardTexture;
        public static int totalWinsX;
        public static int totalWinsO;
        private SmallBoard[,] bigBoardBoards = new SmallBoard[3, 3];
        public BigBoard()
        {
            for (int indexcol = 0; indexcol < 3; indexcol++)
            {
                for (int indexrow = 0; indexrow < 3; indexrow++)
                {
                    bigBoardBoards[indexrow,indexcol] = new SmallBoard(indexrow, indexcol);
                }
                
            }
        }

        

        public void Update()
        {
            if (bigBoardBoards[nextMoveBoardRow, nextMoveBoardCol].getBoardFull() == false)
            {
                bigBoardBoards[nextMoveBoardRow, nextMoveBoardCol].Update();
            }
            else if (bigBoardBoards[nextMoveBoardRow, nextMoveBoardCol].getBoardFull() == true) //if all 9 spaces on a small board are filled, it gives the player a free move and updates all the boards.
            {
                for (int indexcol = 0; indexcol < 3; indexcol++) //This for loop code is used every time I want to do something to every object in the 3x3 array.. which we have multiple 3x3 arrays
                { //loop code
                    for (int indexrow = 0; indexrow < 3; indexrow++) //loop code
                    { //loop code
                        bigBoardBoards[indexrow, indexcol].Update();
                    }
                }
            }
            
            if ((totalWinsX == 5) || (totalWinsO == 5))
            {
                gameOver = true;
            } //------------------------------

            if (!(goOnce == 1)) //this is here so all the boards update once just to initialize and other things...
            {
                for (int indexcol = 0; indexcol < 3; indexcol++) //This for loop code is used every time I want to do something to every object in the 3x3 array.. which we have multiple 3x3 arrays
                {
                    for (int indexrow = 0; indexrow < 3; indexrow++)
                    {
                        bigBoardBoards[indexrow, indexcol].Update();
                    }
                }

                goOnce = 1;
            }
        }

        public void Draw(SpriteBatch spritebatch)
        {
            spritebatch.Draw(bigBoardTexture, new Rectangle(0,0,704,704), Color.White);
            for (int indexcol = 0; indexcol < 3; indexcol++)
            {
                for (int indexrow = 0; indexrow < 3; indexrow++)
                {
                    bigBoardBoards[indexcol, indexrow].Draw(spritebatch);
                }
            }
        }
    }
}
